/******
ブザー用ライブラリ
   waitを使ってないver

使い方
    実際に使ってみること
*****/

#ifndef BUZZER_H
#define BUZZER_H
#include "mbed.h"

class buzzer {
    public:
        /** Create a buzzer instance connected to IOpin
        *
        * @param buzzerPin buzzer connect pin
        */
        buzzer(PinName buzzerPin);
        void output(unsigned int count,float period);       //period周期でcount回圧電ブザーを鳴らす
        void output(bool buzzerStates);                     //false→消音  true→音なる
        void output(float period);                          //period周期でstop()が呼び出されるまでブザーを鳴らす
        void stop();                                        //ブザーを止める
    private:
        DigitalOut _buzzer;
        Ticker     _timer;
        
        void timerFunction();
        int _counter,_setCount,_timerFlag,_loopFlag;
          
};

#endif